--[[
Copyright 2010, 2011 William Matthews. All rights reserved.

See LICENSE for license terms.
]]

local CB = select(2,...)
local P = CB.Private
local Merchant = P:NewModule("Merchant", "AceEvent-3.0")

-- Hook merchant purchase
local function Hook_BuyMerchantItem(index,quantity)
	local link = GetMerchantItemLink(index)
	local name, texture, price, stackQuantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(index)
	local itemCurrencyCount = GetMerchantItemCostInfo(index)

	-- price is the price for stackQuantity items
	-- quantity = nil ==>> quantity = 1
	local q = quantity or stackQuantity
	local pricePer = price / stackQuantity
	
	local itemCurrencies = P.ItemSet.new()

	if itemCurrencyCount and itemCurrencyCount~=0 then
		for i=1,itemCurrencyCount do
			local _, itemCostCount, itemCostLink, itemCostName = GetMerchantItemCostItem(index, i)
			if itemCostLink then -- link is nil for currencies
				itemCurrencies:Inc(P.idOfItem(itemCostLink),itemCostCount*q)
			end
		end
	end
	
	if false then
		P:DebugPrint({
			name=name,
			honorPoints = honorPoints,
			arenaPoints = arenaPoints,
			itemCurrencyCount = itemCurrencyCount,
			quantity = quantity,
			stackQuantity = stackQuantity,
			itemCurrencies = itemCurrencies
		})
	end
	
	local id=P.idOfItem(link)
	P:ReceiveCallback(id,q,function ()
		CB:RecordTransaction(pricePer*q, itemCurrencies,{[id]=q})
	end)
end
hooksecurefunc("BuyMerchantItem",Hook_BuyMerchantItem)
